<?

//    
$StartTime = explode(" ", microtime());

//  
require_once "environment.php";

//      
function GetFileContent($FilePath)
{
	$File = fopen($FilePath, "r");
	$FileSize = filesize($FilePath);
	$FileContent = fread($File, $FileSize);
	fclose($File);
	return str_replace("\r", "", $FileContent);
}

// 
$Topics = array();
// 
$Statistics = array();
//  
$ClassesLinks = array();

//	
//		 
//	

if ($Packages)
{
	$AllPackages = array();
	$Document = GetFileContent($SourceDirectory."api/overview-frame.html");
	$Start = strpos($Document, "Packages");
	$Length = strlen($Document);

	do
	{
		//   
		$Pos1 = strpos($Document, "<A", $Start);
		if ($Pos1 === false) break;
		$Pos1 = strpos($Document, ">", $Pos1) + 1;
		$Pos2 = strpos($Document, "</A>", $Pos1);

		$Package = trim(substr($Document, $Pos1, $Pos2 - $Pos1));
		$PackageNameParts = explode(".", $Package);
		foreach ($PackageNameParts as $NamePart)
			$AllPackages[] = $NamePart;

		$Start = $Pos2 + 4;
	}
	while ($Start < $Length);

	asort($AllPackages);
	$AllPackages = array_unique($AllPackages);
	$Statistics["Packages"] = count($AllPackages);
	$Topics["Packages"] = "\n\n#KEYWORD=Packages\n";
	$Topics["Packages"] .= implode("\n", $AllPackages);
}

//	
//		   
//	

if ($Classes || $Interfaces || $Methods)
{
	$AllClasses = array();
	$AllInterfaces = array();
	$Document = GetFileContent($SourceDirectory."api/allclasses-frame.html");
	$Length = strlen($Document);

	for ($Start = 0; $Start < $Length; $Start = $Pos2 + 4)
	{
		//     
		$Pos1 = strpos($Document, "<A HREF=\"", $Start);
		if ($Pos1 === false) break; else $Pos1 += 9;
		$Pos2 = strpos($Document, "\"", $Pos1);
		$ClassesLinks[] = substr($Document, $Pos1, $Pos2 - $Pos1);

		//   /
		$Pos1 = strpos($Document, ">", $Pos2 + 1) + 1;
		$Pos2 = strpos($Document, "</A>", $Pos1);
		$Class = substr($Document, $Pos1, $Pos2 - $Pos1);

		// ,   
		if (strpos($Class, "<I>") !== false)
		{
			$Class = str_replace("<I>", "", $Class);
			$Class = str_replace("</I>", "", $Class);
			$AllInterfaces[] = trim($Class);
		}
		// ,    
		else $AllClasses[] = trim($Class);
	}

	if ($Classes) //  
	{
		asort($AllClasses);
		$Statistics["Classes"] = count($AllClasses);
		$Topics["Classes"] = "\n\n#KEYWORD=Classes\n";
		$Topics["Classes"] .= implode("\n", $AllClasses);
	}

	if ($Interfaces) //  
	{
		asort($AllInterfaces);
		$Statistics["Interfaces"] = count($AllInterfaces);
		$Topics["Interfaces"] = "\n\n#KEYWORD=Interfaces\n";
		$Topics["Interfaces"] .= implode("\n", $AllInterfaces);
	}
}

//	
//		 
//	

if ($Methods)
{
	$AllMethods = array(); //  

	foreach ($ClassesLinks as $Link)
	{
		//    /
		$FilePath = $SourceDirectory."api/".$Link;
		$Document = GetFileContent($FilePath);

		// ,     
		$Pos1 = strpos($Document, "Method Summary");
		if ($Pos1 === false) continue;

		//   
		$Pos2 = strpos($Document, "</TABLE>", $Pos1);
		$MethodSummary = substr($Document, $Pos1, $Pos2 - $Pos1);
		$Length = strlen($MethodSummary);

		//   /
		$Pos1 = strpos($Document, "<H1>") + 4;
		$Pos1 = strpos($Document, "<BR>\n", $Pos1) + 5;
		$Pos2 = strpos($Document, "</H2>");
		$Class = trim(substr($Document, $Pos1, $Pos2 - $Pos1));
		$AllMethods[$Class] = array();

		//      /
		for ($Start = 0; $Start < $Length; $Start = $Pos2 + 4)
		{
			$Pos1 = strpos($MethodSummary, "<B><A", $Start);
			if ($Pos1 === false) break; else $Pos1 += 5;
			$Pos1 = strpos($MethodSummary, ">", $Pos1) + 1;
			$Pos2 = strpos($MethodSummary, "</A>", $Pos1);
			$Method = trim(substr($MethodSummary, $Pos1, $Pos2 - $Pos1));
			$AllMethods[$Class][] = $Method;
		}

		//   
		$AllMethods[$Class] = array_unique($AllMethods[$Class]);
		//   
		asort($AllMethods[$Class]);
	}

	ksort($AllMethods);	//    /

	$Topics["Methods"] = "\n\n#KEYWORD=Methods";

	if ($UniqueMethodNames) //   
	{
		$Heap = array();

		foreach ($AllMethods as $ClassMethods)
			foreach ($ClassMethods as $Method)
				$Heap[] = $Method;

		asort($Heap);
		$Heap = array_unique($Heap);
		$Statistics["Methods"] = count($Heap);
		$Topics["Methods"] .= "\n".implode("\n", $Heap);
	}
	else //      
	{
		$Statistics["Methods"] = 0;

		foreach ($AllMethods as $Class => $ClassMethods)
		{
			$Topics["Methods"] .= "\n; ".$Class;

			foreach ($ClassMethods as $Method)
			{
				$Topics["Methods"] .= "\n".$Method;
				$Statistics["Methods"]++;
			}
		}
	}
}

//	
//		     
//	

//  Java Software Development Kit
$Document = GetFileContent($SourceDirectory."index.html");
$Pos1 = strpos($Document, "Version") + 7;
$Pos2 = strpos($Document, "<", $Pos1);
$Version = trim(substr($Document, $Pos1, $Pos2 - $Pos1));

//   
$Date = getdate(time());
$Date = $Date["month"]." ".$Date["mday"].", ".$Date["year"];

//  
$Summary = "keywords (50)";
if ($Packages) $Summary .= ", packages (".$Statistics["Packages"].")";
if ($Classes) $Summary .= ", classes (".$Statistics["Classes"].")";
if ($Interfaces) $Summary .= ", interfaces (".$Statistics["Interfaces"].")";
if ($Methods) $Summary .= ", methods (".$Statistics["Methods"].")";
if ($Pos = strrpos($Summary, ","))
	$Summary = substr($Summary, 0, $Pos)
	." and".substr($Summary, $Pos + 1);

$Topics["Header"] = GetFileContent("header.txt");
$Topics["Header"] = str_replace("<!-- Date -->", $Date, $Topics["Header"]);
$Topics["Header"] = str_replace("<!-- Summary -->", $Summary, $Topics["Header"]);
$Topics["Header"] = str_replace("<!-- Version -->", $Version, $Topics["Header"]);

//  
$Keywords = GetFileContent("keywords.txt");
$Keywords = explode("\n", $Keywords);
$Keywords = array_unique($Keywords);
asort($Keywords);
$Topics["Keywords"] = "\n\n#KEYWORD=Keywords";
$Topics["Keywords"] .= "\n".implode("\n", $Keywords);

//	
//		 ,    ,   
//	

//    
$Content = $Topics["Header"].$Topics["Keywords"];
if ($Methods) $Content .= $Topics["Methods"];
if ($Classes) $Content .= $Topics["Classes"];
if ($Interfaces) $Content .= $Topics["Interfaces"];
if ($Packages) $Content .= $Topics["Packages"];

//   
$EndTime = explode(" ", microtime());
$EndTime = (float)$EndTime[0] + (float)$EndTime[1];
$StartTime = (float)$StartTime[0] + (float)$StartTime[1];
$ExecutionTime = number_format($EndTime - $StartTime, 3, ".", "");
$Report = "Execution time: ".$ExecutionTime." sec;";

//   
$TargetFilePath = $TargetDirectory."java.stx";
$Report .= "\n<br/>\n<br/>Result file: <code>".$TargetFilePath."</code>;";
$Report .= "\n<br/>Result file size: ".strlen($Content)." bytes ("
.number_format(strlen($Content) / 1024, 1, ".", "")." KB);";

//    
$Report .= "\n<br/>\n<br/>Keywords: 50;";
if ($Packages) $Report .= "<br/>\nPackages: ".$Statistics["Packages"].";";
if ($Classes) $Report .= "<br/>\nClasses: ".$Statistics["Classes"].";";
if ($Interfaces) $Report .= "<br/>\nInterfaces: ".$Statistics["Interfaces"].";";
if ($Methods) $Report .= "<br/>\nMethods: ".$Statistics["Methods"].";";
$Report[strlen($Report) - 1] = ".";

//   
$File = fopen($TargetFilePath, "w");
fwrite($File, $Content);
fclose($File);

$Preview = str_replace("\n", "<br/>\n", $Content);
require_once "preview.php";

?>